# ..addons/eventscripts/_libs/python/saytextlib.py

import es, os, playerlib, usermsg

_gamename = str(es.ServerVar('eventscripts_gamedir')).rsplit(os.sep, 1)[~0]

_colors = ('#blue','#grey','#red','#team')

_teams = {'#red':'#t','#blue':'#ct'}

def saytext2(users,index=0,message=''):
    if not message:
        es.dbgmsg(0,'saytext2: Syntax: saytext2 <users> [index] <msg>')
    elif _gamename in ('ageofchivalry','cstrike','empires','gesource','hl2mp','Jailbreak','smashball','so','synergy','tf','zps'):
        index, team = _getIndexTeam(index,message)
        teamcolor = _getTeamColor(team)
        message = message.replace('#default','\x01').replace('#green',_getGreenColor()).replace('#lightgreen',_getLGColor(index))
        for color in _colors:
            message = message.replace(color,teamcolor)
        usermsg.saytext2(users,index,message)
    else:
        if users[0] in ('#','!'):
            if not _getFilters(users):
                raise ValueError, "Invalid player filter '%s'%"%users
            users = playerlib.getUseridList(users)
        elif not hasattr(users,'__iter__'):
            users = (users,)
        for color in _colors:
            message = message.replace(color,'#lightgreen')
        for userid in users:
            es.tell(userid,'#multi',message)

def _getIndexTeam(index,message):
    if '#team' in message: return (index,es.getindexprop(index,'CBaseEntity.m_iTeamNum'))
    for color in _teams:
        if color in message:
            players = playerlib.getPlayerList(_teams[color])
            if players: return (players[0].index,players[0].team)
    if '#grey' in message: return (-1,0)
    return (0,0)

def _getFilters(args):
    for arg in args.split(','):
        if not arg.startswith('#') or not arg.startswith('!') or not arg[1:] in filters: return False
    return True

def _getGreenColor():
    if _gamename == 'gesource': return '\x05'
    return '\x04'

def _getTeamColor(team):
    if _gamename in ('cstrike','gesource','tf'): return '\x03'
    if _gamename in ('ageofchivalry','empires','hl2mp','Jailbreak','smashball','so','zps') and team in (2,3): return '\x03'
    if _gamename == 'hl2mp': return '\x04'
    return '\x05'

def _getLGColor(index):
    if _gamename == 'cstrike': return '\x03'
    if _gamename == 'tf' and not index: return '\x03'
    if _gamename in ('gesource','hl2mp'): return '\x04'
    return '\x05'